<template>
    <MdDialog :md-active.sync="show" class="dialog">
        <div class="header">
            <MdDialogTitle class="headerText">{{title}}</MdDialogTitle>
            <div class="headerButton">
                <MdButton class="md-icon-button md-dense" @click="deleteMe">
                    <DeleteIcon />
                </MdButton>
                <MdTooltip>{{$t('details.deleteTodoTooltip', summary)}}</MdTooltip>
            </div>
        </div>
        <MdDialogContent>
            <Editor
                    ref="editor"
                    v-model="editorModel"
                    :fields="[
                          {
                            label: this.$t('summary'),
                            placeholder: this.$t('details.summaryPlaceholder'),
                            key: 'summary',
                            required: true
                          },
                          {
                            label: this.$t('description'),
                            placeholder: this.$t('details.descriptionPlaceholder'),
                            key: 'description',
                            type: 'textarea'
                          }
                        ]"
            />
            <todo-subtasks />
        </MdDialogContent>
        <MdDialogActions>
            <MdButton @click="save()">{{$t('details.save')}}</MdButton>
            <MdButton @click="close()">{{$t('details.close')}}</MdButton>
        </MdDialogActions>
    </MdDialog>
</template>
<script>
    /* eslint-disable no-debugger */
  import Vue from 'vue';
  import { MdDialog, MdButton, MdField } from 'vue-material/dist/components';
  import DeleteIcon from 'vue-material-design-icons/Delete'
  import Subtasks from './Subtasks';
  import { confirm } from '../modals';
  import MdTooltip from '../TouchDeviceDisabledTooltip';
  import i18n from '../../i18n';
  import jsLog from 'js-logger';
  import Editor from '../Editor';

  const log = jsLog.get('Details');

  Vue.use(MdDialog);
  Vue.use(MdButton);
  Vue.use(MdField);

  export default {
    computed: {
      editorModel: {
        get() {
          return this.$store.state.details.openTodo;
        },
        set(model) {
          this.$store.dispatch('updateDetails', model);
        }
      },
      title(){
        return this.$t('details.header', {summary: this.summary});
      },
      summary(){
        return this.$store.state.details.openTodo && this.$store.state.details.openTodo.summary;
      },
      show: {
        get(){
          return !this.$store.state.loading;
        },
        set(show){
          if(!show) this.close();
        }
      }
    },
    i18n,
    methods:{
      save(){
        if(this.$refs.editor.checkFields()){
          this.$store.dispatch('commitDetails');
          this.close();
        }
      },
      close(){
        log.info('close');
        this.$router.push('/');
      },
      async deleteMe(){
        const message = this.$t('details.deleteTodoPrompt', {summary: this.summary});
        const okText = this.$t('details.deleteTodoPromptDeleteButton');
        const ok = await confirm(this, { message, okText });
        this.close();
        if(ok) this.$store.dispatch('deleteAndClose', this.$store.state.details.openTodo.id);
      }
    },
    mounted() {
      log.info('dialog created', this.$route.params.id);
      this.$store.dispatch('details', this.$route.params.id);
    },
    destroyed() {
      log.info('dialog destroyed');
      this.$store.dispatch('details', this.$route.params.id);
    },
    components: {
      DeleteIcon, MdTooltip, 'todo-subtasks': Subtasks, Editor
    }
  }
</script>
<style scoped>
    .header{
        margin-bottom: 10px;
        background-color: var(--md-theme-default-accent);
    }
    .headerText{
        float: left;
    }
    .headerButton{
        float: right;
        margin-top: 20px;
    }
</style>
<style>
    .dialog > DIV{
        width: 500px;
    }
</style>

